<?php
include("GIFDecoder.class.php");
include("GIFEncoder.class.php");

$file="yingyang.gif";
$image = imagecreatefromgif($file);
$transcolor=imagecolortransparent($image);
$w=imagesx($image);
$h=imagesy($image);
$gifcontents=file_get_contents($file);

if(is_gif_animado($gifcontents)){
	$GIFS=new GIFDecoder($gifcontents);
	$ARRS=$GIFS->GIFGetFrames();
	$OFFSETS=$GIFS->GIFGetOffset();

	for($i=0; $i<count($ARRS); $i++){
			if($i>0){
			$image=imagecreatefromstring($ARRS[$i]);
			$wo=imagesx($image);
			$ho=imagesy($image);
			$off=$OFFSETS[$i];
			
			//fusionamos el frame con el anterior
			$temp=imagecreatetruecolor($w, $h);
			$temp2=imagecreatefromstring($ARRS[$i-1]);
			
			if($transcolor!=-1){
				$trnprt_color = imagecolorsforindex($image, $transcolor);
				$trnprt_indx = imagecolorallocate($temp, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);
				imagefill($temp, 0, 0, $trnprt_indx);
				imagecolortransparent($temp, $trnprt_indx);
				imagecolortransparent($image, $transcolor);
			}
			imagecopymerge($temp, $temp2, 0, 0, 0, 0, $w, $h, 100);
			imagecopymerge($temp, $image, $off[0], $off[1], 0, 0, $wo, $ho, 100);
			//el frame ya es del tamao total y fusionado
			ob_start();
			imagegif($temp);
			$ARRS[$i]=ob_get_clean();

			$OFFSETS[$i][0]=0;
			$OFFSETS[$i][1]=0;
			imagedestroy($temp);
		}
	}
	//ahora si queremos podemos redimensionar los frames, por ejemplo hacemos thumbnail
	for($i=0; $i<count($ARRS); $i++){
		$image=imagecreatefromstring($ARRS[$i]);
		$wo=imagesx($image);
		$ho=imagesy($image);
		$dst_img=imagecreatetruecolor (90, 90);
		imagecopyresized($dst_img, $image, 0, 0, 0, 0, 90, 90, $wo, $ho);

		ob_start();
		imagegif($dst_img);
		$ARRS[$i]=ob_get_clean();
	}
	
	$gif = new GIFEncoder($ARRS, $GIFS->GIFGetDelays(), 0, 2, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue'], array(), "bin" );
	$fh = fopen("destino.gif", 'w');
	fwrite($fh, $gif->GetAnimation());
	fclose($fh);
	header("Content-type: image/gif");
	readfile("destino.gif");
	unlink("destino.gif");
}

function is_gif_animado($filecontents){
	//$filecontents=file_get_contents($filename);
	$str_loc=0;
	$count=0;
	while ($count < 2){ // There is no point in continuing after we find a 2nd frame
		$where1=strpos($filecontents,"\x00\x21\xF9\x04",$str_loc);
		if ($where1 === FALSE){
	        break;
		}else{
			$str_loc=$where1+1;
			$where2=strpos($filecontents,"\x00\x2C",$str_loc);
			if ($where2 === FALSE){
				break;
			}else{
				if ($where1+8 == $where2){
					$count++;
				}
				$str_loc=$where2+1;
			}
		}
	}
	if ($count > 1){
		return(true);
	}else{
		return(false);
	}
}

?>